# 环境准备

1. 创建mrs集群，选择开启kerberos，勾选kafka, hbase, hdfs, 安全组规则开通对应UDP/TCP端口；

2. 进入MRS manager管理界面：

   1）[创建机机账号](https://support.huaweicloud.com/usermanual-mrs/mrs_01_0345.html)，需确保该用户含有hdfs_admin, hbase_admin权限，下载该用户认证凭据，其中包含user.keytab 和  krb5.conf 文件；

   2）点击服务管理，下载客户端，点击确定即可，然后到mrs节点上下载配置文件，所需集群配置文件包含hbase-site.xml, hiveclient.properties；

3. 创建DLI 专属集群，与mrs集群[建立跨源连接](https://support.huaweicloud.com/usermanual-dli/dli_01_0426.html)；

4. 获取mrs集群全部节点的ip和域名映射，在DLI跨源连接修改主机中配置host映射;

5. 将步骤2中提及的4个文件添加到工程的resource目录下；

6. 从DRS获取其上传到kafka的avro数据的schema，放置到resources目录下的avro中;

7. 执行mvn clean compile assembly:single编包


注：对接测试的mrs版本为2.0.1，HBase版本为2.1.1，hadoop版本为3.1.1, Kafka版本为2.11-1.1.0


# 用法
1. --source ${sourceType} ${sourceParams} --sink ${sinkType} ${sinkParams}
   其中--source可选，默认为安全kafka

2. source类型及其参数说明
   - 安全kafka参数
     --source.topic kafka源topic
     --bootstrap.servers kafka连接地址, 端口需为安全端口, 可从Kafka客户端consumer.properties中获取
     --group.id(可选) 消费组，默认为test-group
     --encode 源数据编码, 默认为raw string, 支持json/DSR avro
     --json.schema 输入源数据的json schame, encode为json时可配置
     --kerberos.domain.name kafka认证域名，可从Kafka客户端consumer.properties中获取
     --userPrincipal 创建的MRS机机用户名
   - rawRandom(每隔一段时间生成并发送一个随机数)参数
     --sendInterval 数据发送周期

3. sink类型及其参数说明
   - 安全kafka参数
     --sink.topic kafka目的topic
     --bootstrap.servers kafka连接地址, 端口需为安全端口, 可从Kafka客户端producer.properties中获取
     --kerberos.domain.name kafka认证域名，可从Kafka客户端producer.properties中获取
     --userPrincipal 创建的MRS机机用户名
   - 安全HDFS参数
     --basePath 数据存储目录，格式为hdfs://${ip}:${port}/${dir}，ip为namenode节点ip，端口为hdfs rpc端口
     --rolloverInterval(可选) 输出文件翻滚周期，默认为1分钟
     --userPrincipal 创建的MRS机机用户名
   - 安全HBASE参数
     --userPrincipal 创建的MRS机机用户名
   - DCS参数
     --cluster.address dcs集群连接地址，格式为IP:PORT
     --password 认证密码
   - DWS参数
     --db.url 数据库连接地址，格式为jdbc:postgresql://${IP}:${PORT}/${dbName}
     --userName 数据库用户名
     --password 数据库密码
     --tableName 待写入数据表名，格式为${schema}.${table}，需提前创建: create table ${tableName}(${column} varchar);
   - 安全hive参数:
     --userPrincipal 创建的MRS机机用户名
     --zk.server.principal zookeeper server凭证，格式为: zookeeper/hadoop.${default_realm}
     --dbName 连接的数据库名, 默认为default

4. 示例
   - 安全kafka写入hdfs参数
     --source.topic xx --bootstrap.servers xx:21007 --kerberos.domain.name xx --userPrincipal xx --sink hdfs --basePath hdfs://xx:9820/xx
   - 安全kafka写入hbase参数
     --source.topic xx --bootstrap.servers xx:21007 --kerberos.domain.name xx --userPrincipal xx --sink hbase
   - 安全Kafka中Json格式数据写入Hive
     --source.topic xx --bootstrap.servers xx:21007 --kerberos.domain.name xx --userPrincipal xx --encode json --json.schema {"type":"object","properties":{"id":{"type":"string"},"name":{"type":"string"},"age":{"type":"integer"}}} --sink hive --zk.server.principal xx
