package com.huawei.dli.flink.demo.utils;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.OutputStream;
import java.io.PrintStream;

public class Log4jPrintStream  extends PrintStream{
  private static final Logger logger = LoggerFactory.getLogger("SystemOut");
  private static PrintStream instance = new Log4jPrintStream(System.out);

  private Log4jPrintStream(OutputStream out) {
    super(out);
  }

  public static void redirectSystemOut() {
    System.setOut(instance);
  }

  public void print(boolean b) {
    println(b);
  }

  public void print(char c) {
    println(c);
  }

  public void print(char[] s) {
    println(s);
  }

  public void print(double d) {
    println(d);
  }

  public void print(float f) {
    println(f);
  }

  public void print(int i) {
    println(i);
  }

  public void print(long l) {
    println(l);
  }

  public void print(Object obj) {
    println(obj);
  }

  public void print(String s) {
    println(s);
  }

  public void println(boolean x) {
    logger.info(String.valueOf(x));
  }

  public void println(char x) {
    logger.info(String.valueOf(x));
  }

  public void println(char[] x) {
    logger.info(x == null ? null : new String(x));
  }

  public void println(double x) {
    logger.info(String.valueOf(x));
  }

  public void println(float x) {
    logger.info(String.valueOf(x));
  }

  public void println(int x) {
    logger.info(String.valueOf(x));
  }

  public void println(long x) {
    logger.info(String.valueOf(x));
  }

  public void println(Object x) {
    logger.info(String.valueOf(x));
  }

  public void println(String x) {
    logger.info(String.valueOf(x));
  }
}
